/*
 * TeamStats by Mats Bovin (tsppc@mbovin.com)
 * v1.0.0 July 2004
 * Copyright (c) 2004 Mats Bovin
 *
 * This file is part of TeamStats.
 *
 * TeamStats is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TeamStats is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TeamStats; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

using System;
using System.Collections;

namespace MBovin.TeamStats.Core
{
	/// <summary>
	/// Interface for classes that stores TeamStats league files.
	/// </summary>
	public interface ILeagueStore
	{
        void LoadHeader(League league);
        ArrayList LoadTeams(League league);
        ArrayList LoadMatches(League league);
        ArrayList LoadMatches(League league, MatchFilter filterMethod, params object[] args);

        void SaveHeader(League league);
        void SaveTeams(League league, ArrayList listTeams);
        void SaveMatches(League league, ArrayList listMatches);

        void SaveMatch(League league, Match match);
        void SaveTeam(League league, Team team);    
	}
}
