/*
 * TeamStats by Mats Bovin (tsppc@mbovin.com)
 * v1.3.0 February 2007
 * Copyright (c) 2004-07 Mats Bovin
 *
 * This file is part of TeamStats.
 *
 * TeamStats is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TeamStats is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TeamStats; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using MBovin.TeamStats;
using MBovin.TeamStats.Util;

namespace MBovin.TeamStats.UI
{
    /// <summary>
    /// This form displays a log from the last LiveUpdate.
    /// </summary>
    public class LiveUpdateLogForm : System.Windows.Forms.Form
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public LiveUpdateLogForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Build the GUI.
        /// </summary>
        private void InitializeComponent()
        {
            int screenHeight = Screen.PrimaryScreen.WorkingArea.Height;

            Label labelHeaderLog    = new Label();
            labelHeaderLog.Parent   = this;
            labelHeaderLog.Bounds   = new Rectangle(8, 6, 232, 16);
            labelHeaderLog.Font     = new Font("Tahoma", 8F, FontStyle.Regular);
            labelHeaderLog.Text     = Language.GetString("liveupdatelogform", "lastloglabel");

            TextBox textBoxLog      = new TextBox();
            textBoxLog.Parent       = this;
            textBoxLog.Bounds       = new Rectangle(8, 24, 224, screenHeight - 78);
            textBoxLog.Font         = new Font("Tahoma", 8F, FontStyle.Regular);
            textBoxLog.Multiline    = true;
            textBoxLog.Text         = AppState.Instance.LiveUpdateLog;
            textBoxLog.ScrollBars   = ScrollBars.Both;

            Button buttonClose          = new Button();
            buttonClose.Parent          = this;
            buttonClose.Bounds          = new Rectangle(8, screenHeight - 36, 60, 20);
            buttonClose.Font            = MainForm.cButtonFont;
            buttonClose.Text            = Language.GetString("liveupdatelogform", "close");
            buttonClose.DialogResult    = DialogResult.OK;

            this.Text = Language.GetString("liveupdatelogform", "title");;
        }
    }
}
