/*
 * TSCreate by Mats Bovin (tsppc@mbovin.com)
 * v1.0.0 July 2004
 * Copyright (c) 2004 Mats Bovin
 *
 * This file is part of TeamStats.
 *
 * TeamStats is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TeamStats is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TeamStats; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

using System;
using System.Collections.Specialized;
using System.Windows.Forms;

namespace MBovin.TSCreate
{
	/// <summary>
	/// The main class of the GUI-version of TSCreate.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.TextBox textBoxLeagueName;
        private System.Windows.Forms.TextBox textBoxMatchfile;
        private System.Windows.Forms.TextBox textBoxWinPoints;
        private System.Windows.Forms.TextBox textBoxDrawPoints;
        private System.Windows.Forms.TextBox textBoxLossPoints;
        private System.Windows.Forms.TextBox textBoxLine1;
        private System.Windows.Forms.TextBox textBoxLine3;
        private System.Windows.Forms.TextBox textBoxLine4;
        private System.Windows.Forms.TextBox textBoxLine2;
        private System.Windows.Forms.Button buttonMatchFile;
        private System.Windows.Forms.Button buttonCreate;
        private System.Windows.Forms.ComboBox comboBoxTableSort;
        private System.Windows.Forms.OpenFileDialog openFileDialog;
        private System.Windows.Forms.SaveFileDialog saveFileDialog;
        private System.Windows.Forms.Button buttonExit;
		private System.ComponentModel.Container components = null;


        /// <summary>
        /// Constructor.
        /// </summary>
		public MainForm()
		{
			InitializeComponent();

            comboBoxTableSort.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if(disposing)
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.textBoxLeagueName = new System.Windows.Forms.TextBox();
            this.textBoxMatchfile = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.textBoxWinPoints = new System.Windows.Forms.TextBox();
            this.textBoxDrawPoints = new System.Windows.Forms.TextBox();
            this.textBoxLossPoints = new System.Windows.Forms.TextBox();
            this.textBoxLine1 = new System.Windows.Forms.TextBox();
            this.textBoxLine3 = new System.Windows.Forms.TextBox();
            this.textBoxLine4 = new System.Windows.Forms.TextBox();
            this.textBoxLine2 = new System.Windows.Forms.TextBox();
            this.buttonMatchFile = new System.Windows.Forms.Button();
            this.comboBoxTableSort = new System.Windows.Forms.ComboBox();
            this.buttonCreate = new System.Windows.Forms.Button();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.buttonExit = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // textBoxLeagueName
            // 
            this.textBoxLeagueName.Location = new System.Drawing.Point(96, 16);
            this.textBoxLeagueName.MaxLength = 16;
            this.textBoxLeagueName.Name = "textBoxLeagueName";
            this.textBoxLeagueName.Size = new System.Drawing.Size(152, 20);
            this.textBoxLeagueName.TabIndex = 0;
            this.textBoxLeagueName.Text = "";
            // 
            // textBoxMatchfile
            // 
            this.textBoxMatchfile.Location = new System.Drawing.Point(96, 40);
            this.textBoxMatchfile.Name = "textBoxMatchfile";
            this.textBoxMatchfile.Size = new System.Drawing.Size(152, 20);
            this.textBoxMatchfile.TabIndex = 1;
            this.textBoxMatchfile.Text = "";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(88, 23);
            this.label1.TabIndex = 2;
            this.label1.Text = "League name:";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 40);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(88, 23);
            this.label2.TabIndex = 3;
            this.label2.Text = "Match file:";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 80);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(88, 23);
            this.label3.TabIndex = 4;
            this.label3.Text = "Points for win:";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 128);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(88, 23);
            this.label4.TabIndex = 5;
            this.label4.Text = "Points for loss:";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 104);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(88, 23);
            this.label5.TabIndex = 6;
            this.label5.Text = "Points for draw:";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 168);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(88, 23);
            this.label6.TabIndex = 7;
            this.label6.Text = "Sort table by:";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(8, 192);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(88, 23);
            this.label7.TabIndex = 8;
            this.label7.Text = "Lines in table:";
            // 
            // textBoxWinPoints
            // 
            this.textBoxWinPoints.Location = new System.Drawing.Point(96, 80);
            this.textBoxWinPoints.MaxLength = 2;
            this.textBoxWinPoints.Name = "textBoxWinPoints";
            this.textBoxWinPoints.Size = new System.Drawing.Size(32, 20);
            this.textBoxWinPoints.TabIndex = 9;
            this.textBoxWinPoints.Text = "3";
            this.textBoxWinPoints.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxDrawPoints
            // 
            this.textBoxDrawPoints.Location = new System.Drawing.Point(96, 104);
            this.textBoxDrawPoints.MaxLength = 2;
            this.textBoxDrawPoints.Name = "textBoxDrawPoints";
            this.textBoxDrawPoints.Size = new System.Drawing.Size(32, 20);
            this.textBoxDrawPoints.TabIndex = 10;
            this.textBoxDrawPoints.Text = "1";
            this.textBoxDrawPoints.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxLossPoints
            // 
            this.textBoxLossPoints.Location = new System.Drawing.Point(96, 128);
            this.textBoxLossPoints.MaxLength = 2;
            this.textBoxLossPoints.Name = "textBoxLossPoints";
            this.textBoxLossPoints.Size = new System.Drawing.Size(32, 20);
            this.textBoxLossPoints.TabIndex = 11;
            this.textBoxLossPoints.Text = "0";
            this.textBoxLossPoints.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxLine1
            // 
            this.textBoxLine1.Location = new System.Drawing.Point(96, 192);
            this.textBoxLine1.MaxLength = 2;
            this.textBoxLine1.Name = "textBoxLine1";
            this.textBoxLine1.Size = new System.Drawing.Size(32, 20);
            this.textBoxLine1.TabIndex = 12;
            this.textBoxLine1.Text = "";
            this.textBoxLine1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxLine3
            // 
            this.textBoxLine3.Location = new System.Drawing.Point(176, 192);
            this.textBoxLine3.MaxLength = 2;
            this.textBoxLine3.Name = "textBoxLine3";
            this.textBoxLine3.Size = new System.Drawing.Size(32, 20);
            this.textBoxLine3.TabIndex = 13;
            this.textBoxLine3.Text = "";
            this.textBoxLine3.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxLine4
            // 
            this.textBoxLine4.Location = new System.Drawing.Point(216, 192);
            this.textBoxLine4.MaxLength = 2;
            this.textBoxLine4.Name = "textBoxLine4";
            this.textBoxLine4.Size = new System.Drawing.Size(32, 20);
            this.textBoxLine4.TabIndex = 14;
            this.textBoxLine4.Text = "";
            this.textBoxLine4.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // textBoxLine2
            // 
            this.textBoxLine2.Location = new System.Drawing.Point(136, 192);
            this.textBoxLine2.MaxLength = 2;
            this.textBoxLine2.Name = "textBoxLine2";
            this.textBoxLine2.Size = new System.Drawing.Size(32, 20);
            this.textBoxLine2.TabIndex = 15;
            this.textBoxLine2.Text = "";
            this.textBoxLine2.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBoxNumeric_KeyPress);
            // 
            // buttonMatchFile
            // 
            this.buttonMatchFile.Location = new System.Drawing.Point(256, 40);
            this.buttonMatchFile.Name = "buttonMatchFile";
            this.buttonMatchFile.Size = new System.Drawing.Size(24, 24);
            this.buttonMatchFile.TabIndex = 16;
            this.buttonMatchFile.Text = "...";
            this.buttonMatchFile.Click += new System.EventHandler(this.ButtonMatchFile_Click);
            // 
            // comboBoxTableSort
            // 
            this.comboBoxTableSort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxTableSort.Items.AddRange(new object[] {
                                                                   "Goal difference, wins",
                                                                   "Goal difference, goals for",
                                                                   "Wins, goal difference",
                                                                   "Wins, goals for",
                                                                   "Goals for, goal differnce",
                                                                   "Goals for, wins"});
            this.comboBoxTableSort.Location = new System.Drawing.Point(96, 168);
            this.comboBoxTableSort.Name = "comboBoxTableSort";
            this.comboBoxTableSort.Size = new System.Drawing.Size(152, 21);
            this.comboBoxTableSort.TabIndex = 17;
            // 
            // buttonCreate
            // 
            this.buttonCreate.Location = new System.Drawing.Point(16, 240);
            this.buttonCreate.Name = "buttonCreate";
            this.buttonCreate.Size = new System.Drawing.Size(72, 32);
            this.buttonCreate.TabIndex = 18;
            this.buttonCreate.Text = "Create file";
            this.buttonCreate.Click += new System.EventHandler(this.ButtonCreate_Click);
            // 
            // openFileDialog
            // 
            this.openFileDialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            // 
            // saveFileDialog
            // 
            this.saveFileDialog.Filter = "TeamStats files (*.ts)|*.ts|All files (*.*)|*.*";
            // 
            // buttonExit
            // 
            this.buttonExit.Location = new System.Drawing.Point(104, 240);
            this.buttonExit.Name = "buttonExit";
            this.buttonExit.Size = new System.Drawing.Size(72, 32);
            this.buttonExit.TabIndex = 19;
            this.buttonExit.Text = "Exit";
            this.buttonExit.Click += new System.EventHandler(this.ButtonExit_Click);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(328, 294);
            this.Controls.Add(this.buttonExit);
            this.Controls.Add(this.buttonCreate);
            this.Controls.Add(this.comboBoxTableSort);
            this.Controls.Add(this.buttonMatchFile);
            this.Controls.Add(this.textBoxLine2);
            this.Controls.Add(this.textBoxLine4);
            this.Controls.Add(this.textBoxLine3);
            this.Controls.Add(this.textBoxLine1);
            this.Controls.Add(this.textBoxLossPoints);
            this.Controls.Add(this.textBoxDrawPoints);
            this.Controls.Add(this.textBoxWinPoints);
            this.Controls.Add(this.textBoxMatchfile);
            this.Controls.Add(this.textBoxLeagueName);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Name = "MainForm";
            this.Text = "TSCreate v1.0";
            this.ResumeLayout(false);

        }
		#endregion

        #region Events

        /// <summary>
        /// Opens the file dialog.
        /// </summary>
        private void ButtonMatchFile_Click(object sender, System.EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                textBoxMatchfile.Text = openFileDialog.FileName;
            }
            
        }

        /// <summary>
        /// Event handler for the Create-button.
        /// </summary>
        private void ButtonCreate_Click(object sender, System.EventArgs e)
        {
            if (ValidateInput())
            {            
                NameValueCollection props = new NameValueCollection();
                props.Add("matchfile", textBoxMatchfile.Text);
                props.Add("leaguename", textBoxLeagueName.Text);
                props.Add("winpoints", textBoxWinPoints.Text);
                props.Add("drawpoints", textBoxDrawPoints.Text);
                props.Add("losspoints", textBoxLossPoints.Text);
                props.Add("tablesort", comboBoxTableSort.SelectedIndex.ToString());
                props.Add("line1", textBoxLine1.Text);
                props.Add("line2", textBoxLine2.Text);
                props.Add("line3", textBoxLine3.Text);
                props.Add("line4", textBoxLine4.Text);
                
                try
                {
                    TSFile tsFile = new TSFile();
                    tsFile.LoadData(props);

                    if (tsFile.Warnings.Length > 0)
                    {
                        string msgText = "The file can be created but the following warnings were generated:\n\n";
                        foreach (string s in tsFile.Warnings)
                        {
                            msgText += (s + "\n");
                        }

                        MessageBox.Show(msgText, "Guru meditation", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }

                    saveFileDialog.FileName = tsFile.GetDefaultFilename();
                    if (saveFileDialog.ShowDialog() == DialogResult.OK)
                    {
                        tsFile.Save(saveFileDialog.FileName);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error occurred:\n" + ex.Message, "Guru meditation", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }

        }

        /// <summary>
        /// A charcater is entered in one of the numeric text boxes.
        /// Checks that it's a digit or backspace.
        /// </summary>
        private void TextBoxNumeric_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!(Char.IsDigit(e.KeyChar) || e.KeyChar == 8))
            {
                e.Handled = true;
            }
        }

        /// <summary>
        /// Exit application.
        /// </summary>
        private void ButtonExit_Click(object sender, System.EventArgs e)
        {
            Application.Exit();
        }

        #endregion
        
        /// <summary>
        /// Validate the data in the form. A message box with error
        /// information will be displayed if any errors are found.
        /// </summary>
        /// <returns>True if all data is ok, false otherwise.</returns>
        private bool ValidateInput()
        {
            if (textBoxLeagueName.Text.Trim().Length == 0)
            {
                MessageBox.Show("You must enter a league name.", "Guru meditation", MessageBoxButtons.OK, MessageBoxIcon.Information);
                textBoxLeagueName.Focus();
                return false;
            }

            if (textBoxMatchfile.Text.Trim().Length == 0)
            {
                MessageBox.Show("You must select a match file.", "Guru meditation", MessageBoxButtons.OK, MessageBoxIcon.Information);
                textBoxMatchfile.Focus();
                return false;
            }

            return true;
        }

        /// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
            Application.Run(new MainForm());
 		}

	}
}
